<?php defined('_JEXEC') or die('Restricted access');

class pm_parspal extends PaymentRoot
{

	function showPaymentForm($params, $pmconfigs)
	{
		include(dirname(__FILE__)."/paymentform.php");
	}

	function showAdminFormParams($params)
	{
		$array_params = array('parspal_apiKey', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
		foreach ($array_params as $key)
		{
			if (!isset($params[$key])) $params[$key] = '';
		}
      if (!isset($params['use_ssl'])) $params['use_ssl'] = 0;
      if (!isset($params['address_override'])) $params['address_override'] = 0;
		$orders = JSFactory::getModel('orders', 'JshoppingModel');
		include(dirname(__FILE__)."/adminparamsform.php");
	}

	function checkTransaction($pmconfigs, $order, $act)
	{
		$jshopConfig = JSFactory::getConfig();
		$pm_method = $this->getPmMethod();
		$orderID = $_REQUEST['orderID'];
		require_once(dirname(__FILE__) . '/parspal_payment_helper.class.php');
		$p = new Parspal_Payment_Helper($pmconfigs['parspal_apiKey']);
		$r = $p->paymentVerify($_POST, intval(ceil($order->order_total)));
		if ($r)
		{
			saveToLog("payment.log", "Order ID ".$orderID.". pay verified ".$p->txn_id);
			return array(1, "پرداخت با موفقیت انجام شد. شماره سفارش: $orderID , شماره پیگیری: ".$p->txn_id, $p->txn_id, $_REQUEST);
		}
		else
		{
			saveToLog("payment.log", "Order ID ".$orderID.". pay failed ".$p->error);
			return array(0, 'پرداخت لغو شد. ' . $p->error, 0, $_REQUEST);
		}
	}

	function showEndForm($pmconfigs, $order)
	{
		$jshopConfig = JSFactory::getConfig();
		$pm_method = $this->getPmMethod();
		$item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
		$uri = JURI::getInstance();
		$liveurlhost = $uri->toString(array("scheme",'host', 'port'));
		$return = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=".$pm_method->payment_class);
		$return .= "&orderID=".$order->order_id;
		require_once(dirname(__FILE__) . '/parspal_payment_helper.class.php');
		$p = new Parspal_Payment_Helper($pmconfigs['parspal_apiKey']);
		$r = $p->paymentRequest(array(
				'amount'      => intval(ceil($order->order_total)),
				'order_id'    => $order->order_id,
				'description' => $item_name,
				'return_url'  => $return,
				'payer'       => array(
				'name'        => @$order->d_f_name.' '.@$order->d_l_name,
				'email'       => @$order->email,
				'mobile'      => @$order->d_phone,
			)));

		if ($r)
		{
			$p->redirect(true);
		}
		else
		{
			echo $p->error;
		}
		exit;
	}

	function getUrlParams($pmconfigs)
	{
		$params = array();
		$params['order_id'] = JRequest::getInt("orderID");
		$params['hash'] = "";
		$params['checkHash'] = 0;
		$params['checkReturnParams'] = 1;
		return $params;
	}

}

?>